<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseApiController;
use App\Http\Base\BaseController;
use App\Http\Handler\CurlHandler;
use App\Http\Handler\SyncHandler;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\ItemService;
use App\Http\Validators\ItemValidator;
use App\Http\Services\ItempopenerimaanService;

class ItemController extends BaseController
{
    protected $baseService;
    protected $validator;

    /**
     * Item constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new ItemService();
        $this->itempopenerimaanService = new ItempopenerimaanService();
        $this->validator = new ItemValidator();

    }

    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $this->validator->beforeInsert($request->all());
        if ($this->validator->hasError()) {
            return $this->validator->validateView();
        }
        DB::beginTransaction();
        try {
            $this->baseService->store($request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/item")->with("successMessages", "Data has been created");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Http\JsonResponse
     */
    public function paging(Request $request)
    {
        $this->data["criteria"] = [
            // "id" => "id" , 
            "namaItem" => "Nama Item"
            , "deskripsi" => "Deskripsi"
        ];
        $this->data["ordering"] = [ 
            "namaItem:asc" => "Kode Item &uarr;"
            , "namaItem:desc" => "Kode Item &darr;"
            , "deskripsi:asc" => "Deskripsi &uarr;"
            , "deskripsi:desc" => "Deskripsi &darr;"
        ];
        
        $input = $request->all();
        $this->data["list"] = isset($input["list"]) && $input["list"] == "list" ? "list" : "grid";
        $this->data["items"] = $this->baseService->paging($request);
        return view("modules.item.item_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($id)
    {
        $this->data["item"] = $this->baseService->show($id);
        return view("modules.item.item_edit", $this->data);
    }


    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->update($id, $request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/item")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create()
    {
        return view("modules.item.item_create", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Http\JsonResponse
     */
    public function show($id, $kapalId = "")
    {
        $this->data["item"] = $this->baseService->show($id, $kapalId);
        if($this->data["item"]) {
            return view("modules.item.item_show", $this->data);
        } else {
            return redirect()->to("administrator/item")->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\JsonResponse
     */
    public function search(Request $request) {
        $data = $this->baseService->paging($request->all());
        echo json_encode($data); 
    } 


    public function posearch(Request $request) {
        $data = $this->itempopenerimaanService->paging($request->all());
        echo json_encode($data); 
    } 

}